 	    	   /******************************************
		   *		    ICNTR.C		     *
	    	   * Copyright TimeSlice, Inc. 1985, 86, 87. *
	    	   ******************************************/

#include <ts.h>

/***
* ICNTR( IP )
* This ISR's IP->arg is a pointer to a WPROC structure. This WPROC contains
* the information necessary to wakeup (using wakeproc()) a process every
* n interrupts. Each time wakeproc is called, the counter is reset to n_ticks. 
***/
void icntr( ip )
INTLST *ip ;
{
  WPROC *wp;

  wp = (WPROC *)ip->arg;
  if( wp->cntr-- )			/* can we wake up this process yet ? */
    return ;			 	/* No, return */
  wp->cntr = wp->reset; 		/* reset counter */
  wakeproc( wp->pptr , ip->intno ) ;	/* wakeup, process */
}


