 	     	   /******************************************
		   *		   MKPTR.C		     *
	    	   * Copyright TimeSlice, Inc. 1985, 86, 87. *
	    	   ******************************************/

#include <ts.h>

/***
* D_SEG( DPTR )
* D_OFF( DPTR )
* Return, independently of memory model or compiler, the SEGment or OFFset
* of a Data pointer.
***/
#if defined(ML) || defined(MD)
unsigned d_seg( off, seg )
unsigned int off, seg ;
{
  return seg ;
}

#else
unsigned d_seg( off )
unsigned int off;
{
  return _datseg ;
}
#endif

unsigned d_off( off, seg )
unsigned int off, seg ;
{
  return off ;
}


/***
* F_SEG( FPTR )
* F_OFF( FPTR )
* Return, independently of memory model or compiler, the SEGment or OFFset
* of a Function pointer.
***/
#if defined(ML) || ( defined(MICROSOFT) && defined(MP) ) || ( defined(TURBOC) && defined(MP) )
unsigned f_seg( off, seg )
unsigned int off, seg ;
{
  return seg;
}
unsigned f_off( off, seg )
unsigned int off, seg ;
{
  return off;
}
#endif
#if ( defined(LATTICE) & defined(MP) )
unsigned f_seg( func )
unsigned int *func;
{
  return func[1];
}
unsigned f_off( func )
unsigned int *func;
{
  return func[0];
}
#endif
#if defined(MD) || defined(MS)
unsigned f_seg( func )
unsigned int func;
{
  return _codseg;
}
unsigned f_off( func )
unsigned int func;
{
  return func;
}
#endif

